﻿using System.IO;
using System.Net.Sockets;
using System.Threading.Tasks;
using EchoTcpServer;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace EchoTcpServerTest
{
    [TestClass]
    public class UnitTest1
    {
        private const int Port = Program.Port;
        private static EchoServer _server;

        [ClassInitialize]
        public static void TestStart(TestContext context)
        {
            _server = new EchoServer(Port);
            Task.Run(() => _server.Start());
        }

        [ClassCleanup]
        public static void TestStop()
        {
            _server.Stop();
        }

        [TestMethod]
        public void TestEchoServer()
        {
            string request = "Hello world";
            string response = GetResponse(request);
            Assert.AreEqual(request, response);

            request = "";
            response = GetResponse(request);
            Assert.AreEqual(request, response);
        }

        private static string GetResponse(string request)
        {
            const string server = "localhost"; // Dns.GetHostName();
            using (TcpClient client = new TcpClient(server, Port))
            {
                NetworkStream stream = client.GetStream();
                StreamWriter writer = new StreamWriter(stream);
                writer.WriteLine(request);
                writer.Flush();
                StreamReader reader = new StreamReader(stream);
                string response = reader.ReadLine();
                return response;
            }
        }
    }
}
